
/*
	File:		CollectionLibrary.h

	Contains:	This file defines interfaces to the printing Collection library.

	Version:	Quickdraw GX 1.1

	Written by:	Dave Hersey

	Copyright:	 1994-1995 by Apple Computer, Inc., all rights reserved.

	File Ownership:

		DRI:        		     	Dave Hersey

		Other Contact:	Ron Voss

		Technology: 		QuickDraw GX

	Change History (most recent first):

		 <1>	  6/6/95	DH		First checked in.
*/

#ifndef _COLLECTIONLIBRARY_
#define _COLLECTIONLIBRARY_

#include <Errors.h>
#include <GXPrinting.h>
#include <Collections.h>

/* Collection routines */

OSErr	GetCollectionItemCategory (Collection theCollection, CollectionTag theTag, long tagID, gxCollectionCategory *theCategory);
OSErr	SetCollectionItemCategory (Collection theCollection, CollectionTag theTag, long tagID, gxCollectionCategory theCategory);
OSErr	RemoveCollectionCategory (Collection theCollection, gxCollectionCategory theCategory);
OSErr	GetCollectionItemLock (Collection theCollection, CollectionTag theTag, long tagID, Boolean *isLocked);
OSErr	SetCollectionItemLock (Collection theCollection, CollectionTag theTag, long tagID, Boolean lockIt);

OSErr	AddJobItem (gxJob theJob, CollectionTag theTag, long id, long itemSize, void *itemData);
OSErr	AddFormatItem (gxFormat theFormat, CollectionTag theTag, long id, long itemSize, void *itemData);
OSErr	AddVolatileJobItem (gxJob theJob, CollectionTag theTag, long id, long itemSize, void *itemData);
OSErr	AddVolatileFormatItem (gxFormat theFormat, CollectionTag theTag, long id, long itemSize, void *itemData);

#endif
