
/*
	File:		DecompressShape.h

	Contains:	graphics libraries - shape decompression

	Written by:	Mike Reed

	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.

	Writers:

		(jtd)	John Daggett

	Change History (most recent first):

		 <1>	 9/14/95	jtd		First checked in.
*/

#pragma once
#ifndef decompressShapeIncludes
	#define decompressShapeIncludes

	#include <QuickDraw.h>
	#include <GXTypes.h>

	#ifdef __cplusplus
	extern "C" {
	#endif
	
	Handle CreateQDGXStream(gxShape source, PicHandle proxie, Boolean forPrintingOnly, Boolean eraseBackground);
	PicHandle DecompressShape(gxShape theShape, PicHandle proxie, Boolean forPrintingOnly, Boolean eraseBackground);
	PicHandle ShapeToPICT(gxShape source);
	void ShapeToScrap(gxShape source, Boolean addProxie, Boolean forPrintingOnly, Boolean eraseBackground);
	void DragAndDropShape(EventRecord* event, gxShape shape);

	#ifdef __cplusplus
	};
	#endif
#endif
