
/*
	File:		JobFormatModeLibrary.h

	Contains:	This file defines interfaces to the printing JobFormatMode library.

	Version:	Quickdraw GX 1.1

	Written by:	Dave Hersey

	Copyright:	 1994-1995 by Apple Computer, Inc., all rights reserved.

	File Ownership:

		DRI:             	Dave Hersey

		Other Contact:		Ron Voss

		Technology: 		QuickDraw GX

	Change History (most recent first):

		 <1>	  6/6/95	DH		First checked in.
*/

#ifndef		_JOBFORMATMODELIBRARY_
#define		_JOBFORMATMODELIBRARY_

#include <GXPrinting.h>

/* Job format mode routines */

gxPositionConstraintTableHdl		GetJobFormatLineConstraint(gxJob theJob, gxPositionConstraintTableHdl thePositionsTable);
gxFontTableHdl							GetJobFormatFonts(gxJob theJob, gxFontTableHdl theFontTable);
gxStyleNameTableHdl					GetJobFormatFontCommonStyles(gxJob theJob, gxFont theFont, gxStyleNameTableHdl theStyleNameTable);
gxPositionConstraintTableHdl		GetJobFormatFontConstraint(gxJob theJob, gxFont theFont, gxPositionConstraintTableHdl thePositionsTable);
gxStyle									SetStyleJobFormatCommonStyle(gxJob theJob, Str255 theStyleName, gxStyle theStyle);

#endif