
/*
	File:		PaperTypeLibrary.h

	Contains:	This file defines interfaces to the printing PaperType library.

	Version:	Quickdraw GX 1.1

	Written by:	Dave Hersey

	Copyright:	 1994-1995 by Apple Computer, Inc., all rights reserved.

	File Ownership:

		DRI:             	Dave Hersey

		Other Contact:		Ron Voss

		Technology: 		QuickDraw GX

	Change History (most recent first):

		 <1>	  6/6/95	DH		First checked in.
*/

#ifndef _PAPERTYPELIBRARY_
#define _PAPERTYPELIBRARY_

#include <GXPrinting.h>

/* Papertype routines */

long					GetPaperTypeBaseType (gxPaperType thePaperType);
void					SetPaperTypeBaseType (gxPaperType thePaperType, long theBasePaperType);
unsigned long		GetPaperTypeCreator(gxPaperType thePaperType);
void					SetPaperTypeCreator (gxPaperType thePaperType, OSType theCreator);
unsigned char		GetPaperTypeUnits (gxPaperType thePaperType);
void					SetPaperTypeUnits (gxPaperType thePaperType, unsigned char theUnits);
unsigned long		GetPaperTypeFlags (gxPaperType thePaperType);
void					SetPaperTypeFlags (gxPaperType thePaperType, unsigned long theFlags);
void					GetPaperTypeComment (gxPaperType thePaperType, Str255 theComment);
OSErr					SetPaperTypeComment (gxPaperType thePaperType, Str255 theComment);
void					LockFormatPaperType (gxFormat theFormat, Boolean lockPaperType);

#endif
