
/*
	File:		QDGXMovieLibrary.h

	Contains:	graphics libraries - GX movies

	Written by:	Mike Reed

	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <1>	  5/2/95	jtd		First checked in.

*/

#ifndef __QDGXMovieLibrary__
#define __QDGXMovieLibrary__

#include <Movies.h>
#include <ImageCompression.h>
#include <GXTypes.h>

#ifdef __cplusplus
	extern "C" {
#endif

typedef struct {
	ImageDescriptionHandle	description;

	Movie				movie;
	Track				track;
	Media				media;

	FSSpec				movieDataSpec;
	short				resourceRefNum;
} QDGXRecorder;

void InitializeQDGXRecorder(QDGXRecorder *mr, const FSSpec* spec, Fixed width, Fixed height);
void AddQDGXRecorderFrame(QDGXRecorder *mr, gxShape source, long duration, Boolean eraseBackground);
void TerminateQDGXRecorder(QDGXRecorder *mr);

#ifdef __cplusplus
	}
#endif

#endif
