/*
	File:			GXEditDebug.h
	
	Contains:
	
	Written by:		Barton R. House
	
	Copyright:		 1993 by Apple Computer, Inc., All rights reserved.
	
*/

#ifndef _H_GXEditDebug
#define _H_GXEditDebug

#ifndef __MEMORY__
#include <Memory.h>
#endif


#ifndef _GXEditDebugPrivate_

#define GXEditDebug	0

#if GXEditDebug

#define HLock(x)				gxEditHLock(x)
#define HUnlock(x)				gxEditHUnlock(x)
#define NewPtr(x)				gxEditNewPtr(x)
#define DisposePtr(x)			gxEditDisposePtr(x)
#define NewHandle(x)			gxEditNewHandle(x)
#define SetHandleSize(x,y)		gxEditSetHandleSize(x,y)
#define DisposeHandle(x)		gxEditDisposeHandle(x)
#define MoveBytes(x,y,z)		gxEditBlockMove(x,y,z)
#define PtrAndHand(x,y,z)		gxEditPtrAndHand(x,y,z)
#define HandToHand(x)			gxEditHandToHand(x)
#define PtrToHand(x,y,z)		gxEditPtrToHand(x,y,z)
#define GetHandleSize(x)		gxEditGetHandleSize(x)

#endif

#endif

void	gxEditHLock(Handle h);
void	gxEditHUnlock(Handle h);
Ptr		gxEditNewPtr(long size);
void	gxEditDisposePtr(Ptr p);
void 	gxEditSetHandleSize(Handle h, unsigned long size);
Handle	gxEditNewHandle(long size);
void 	gxEditDisposeHandle(Handle h);
void	gxEditBlockMove(Ptr src, Ptr dst, unsigned long size);
void	gxEditPtrAndHand(Ptr p, Handle h, unsigned long size);
void	gxEditHandToHand(Handle * h);
void	gxEditPtrToHand(Ptr p, Handle * h, unsigned long size);
long	gxEditGetHandleSize(Handle h);

void *	AddBlock(long l, unsigned long size, Boolean isHandle);
void	RemoveBlock(long l);

#endif