/*
	File:			GXEditStyle.h
	
	Contains:
	
	Written by:		Barton R. House
	
	Copyright:		 1993 by Apple Computer, Inc., All rights reserved.
	
*/

#ifndef _H_Style
#define _H_Style

#ifndef layoutTypesIncludes
#include "layout types.h"
#endif

void			IncrementDocStyleRefCount(DocPtr dp, short styleIndex);
void			DecrementDocStyleRefCount(DocPtr dp, short styleIndex);

void 			InitDocStyle(gxStyle textStyle, StylePtr newStyle);
short		FindDocStyle(DocPtr dp, StylePtr sp);
short		AddDocTextStyle(DocPtr dp, gxStyle textStyle);
StylePtr		GetDocStyle(DocPtr dp, short styleIndex);

short		SetDocStyleTextFont(DocPtr dp, short styleIndex, gxFont fontId);
gxFont		GetDocStyleTextFont(DocPtr dp, short styleIndex);

short		SetDocStyleTextSize(DocPtr dp, short styleIndex, short size);
short		GetDocStyleTextSize(DocPtr dp, short styleIndex);

short		SetDocStyleFeatures(DocPtr dp, short styleIndex, short numFeatures, gxRunFeature * features);
void			GetDocStyleFeatures(DocPtr dp, short styleIndex, short * numFeatures, gxRunFeature * features);
										
short		SetDocStyleEncoding(DocPtr dp, short styleIndex, gxFontPlatform platform, gxFontScript script, gxFontLanguage language);


void			ModifyStyleFeatures(DocPtr dp, gxFont fontId, short numFeatureGroups,
									short * srcFeatureGroupSizes,
									gxRunFeature ** srcFeatureGroups,
									short * dstFeatureGroupSizes,
									gxRunFeature ** dstFeatureGroups,
									short numStyles, short * oldStyles, short * newStyles);

void			ModifyStyleVariations(DocPtr dp, gxFont fontId, short numVariations, gxFontVariation * variations,
									short numStyles, short * oldStyles, short * newStyles);

void			ModifyStyleRunControls(DocPtr dp, gxRunControls * newRunControls,
									gxRunControls * runControlsMask,
									short numStyles, short * oldStyles, short * newStyles);


void 			ModifyStyleTextFonts(DocPtr dp, short numFonts, gxFont * srcFonts, gxFont * dstFonts,
									short numStyles, short * oldStyles, short * newStyles);

void			ModifyStyleTextSize(DocPtr dp, short textSize, short numStyles, short * oldStyles, short * newStyles);

void			UnionStyleFeatures(DocPtr dp, short numStyles, short *styles,
									gxFont fontId, short * numFeatureGroupsPtr,
									short *** featureGroupSizesPtr,
									gxRunFeature **** featureGroupsPtr);

void			UnionStyleVariations(DocPtr dp, short numStyles, short *styles,
						gxFont fontId, short * numInstancesPtr,
						short *** instanceSizesPtr, gxFontVariation **** instancesPtr);

void			UnionStyleRunControls(DocPtr dp, short numStyles, short *styles,
									gxRunControls * runControls, gxRunControls * runControlsMask);

void			UnionFontRunControls(DocPtr dp, short numStyles, short *styles, gxFont fontId,
									gxRunControls * runControls, gxRunControls * runControlsMask);
#endif
