#
#   File:       QDGX shell.mpwfat.make
#
#   Target:     QDGX shell.mpwfat 
#
#	Why:	This makefile creates a "FAT" version of the QuickDraw GX sample shell app
#				Since we built a "FAT" version of this app, it will run on a 68k or PowerPC Mac running
#				QuickDraw GX v1.0 or newer.
#
#   Sources:    "{GXLIBRARIES}ColorLibrary.c"
#               "{GXLIBRARIES}FontLibrary.c"
#               "{GXLIBRARIES}GraphicsDebugLibrary.c"
#               "{GXLIBRARIES}ShapeLibrary.c"
#               "{GXLIBRARIES}TransformLibrary.c"
#               "QDGX shell.r"
#               "QDGX shell.c"
#               "QDGX shell misc.c"
#               "QDGX shell printing.c"
#               "put your code here.c"
#
#   Created:    Wednesday, December 22, 1993 05:09:44 PM
#
#				 6/20/96	cn		Updated to support MPW Pro #19.
#

ThisMakeFile		=	QDGX shell.mpwfat.make

GXINTERFACES 		= {CIncludes}
SOURCE					=	:
OBJ68K					=	:Obj68K:
OBJPPC					=	:ObjPPC:
GXLIBRARIES 		= {MPW}GXLibraries:
GXLIBRARIES68K 	= {Obj68K}
GXLIBRARIESPPC 	= {ObjPPC}

68KOBJECTS 		=	"{GXLIBRARIES68K}ColorLibrary.c.o" 
								"{GXLIBRARIES68K}FontLibrary.c.o" 
								"{GXLIBRARIES68K}GraphicsDebugLibrary.c.o" 
								"{GXLIBRARIES68K}ShapeLibrary.c.o"			
								"{GXLIBRARIES68K}TransformLibrary.c.o" 
								"{OBJ68K}QDGX shell.c.o" 
								"{OBJ68K}QDGX shell misc.c.o" 
								"{OBJ68K}QDGX shell printing.c.o" 
								"{OBJ68K}put your code here.c.o" 

POWERPCOBJECTS 	= 	"{GXLIBRARIESPPC}ColorLibrary.o"
										"{GXLIBRARIESPPC}FontLibrary.o" 
										"{GXLIBRARIESPPC}GraphicsDebugLibrary.o" 
										"{GXLIBRARIESPPC}ShapeLibrary.o"			
										"{GXLIBRARIESPPC}TransformLibrary.o" 
										"{OBJPPC}QDGX shell.o" 
										"{OBJPPC}QDGX shell misc.o" 
										"{OBJPPC}QDGX shell printing.o" 
										"{OBJPPC}put your code here.o" 

#
# MakePEF allows us to "weak" link to QuickDrawGXLib so our PowerPC code can run if the library
# isn't present.  It's up to the app to check before we call any of the GX functions, though.  
# We specify weaking linking by the end of the -weakLib option to PPCLink (see below).
#

#
#	You need to define debugging to enable all of the GX warnings available only in the 
#	debugging version of the QuickDraw GX debugging init.
#
CSYMOPTIONS			= -sym on
COPTIONS 				= -d debugging -i "{GXINTERFACES}" -i "{GXLIBRARIES}" {CSYMOPTIONS}

PPCSYMOPTIONS		= -sym on
PPCCOPTIONS 		= -d debugging -i "{GXINTERFACES}" -i "{GXLIBRARIES}" {PPCSYMOPTIONS}


#------------------------------------------------------------------------------
# These are modified default build rules.  This is so we can automatically 
# build for both 68K and PowerPC.
#------------------------------------------------------------------------------
"{OBJ68K}"					"{SOURCE}"

"{GXLIBRARIES68K}"		"{GXLIBRARIES}"

.c.o						.c
	{C} {COptions} {DepDir}{Default}.c -o {TargDir}{Default}.c.o

"{OBJPPC}"					"{SOURCE}"

"{GXLIBRARIESPPC}"		"{GXLIBRARIES}"

.o							.c
	MrCpp {PPCCOptions} {DepDir}{Default}.c -o {TargDir}{Default}.o

#------------------------------------------------------------------------------


"QDGX shell.mpwfat"   "{ThisMakeFile}" 'QDGX shell.r'
	Rez 'QDGX shell.r' -append -o "QDGX shell.mpwfat"

"QDGX shell.mpwfat"  "{ThisMakeFile}"  {POWERPCOBJECTS}
	PPCLink  {PPCSYMOPTIONS} 
		{POWERPCOBJECTS} 
		"{SharedLibraries}"InterfaceLib 
		"{PPCLibraries}"QuickDrawGXLib.xcoff 
		"{SharedLibraries}"MathLib 
		"{SharedLibraries}"StdCLib 
		"{PPCLibraries}"StdCRuntime.o 
		"{PPCLibraries}"PPCCRuntime.o 
		-main __start 
		-o "QDGX shell.mpwfat" 
		-librename InterfaceLib.xcoff=InterfaceLib 
  	-librename QuickDrawGXLib.xcoff=QuickDrawGXLib 
		-librename MathLib.xcoff=MathLib 
		-librename StdCLib.xcoff=StdCLib 
		-weakLib QuickDrawGXLib 
		-t APPL -c '????'
	MakeSYM -i "{GXLIBRARIESGXLIBRARIES}" "QDGX shell.mpwfat.xcoff" -o "QDGX shell.mpwfat.xSYM"

"QDGX shell.mpwfat"  "{ThisMakeFile}"  {68KOBJECTS}
	Link -t APPL -c '????' {CSYMOPTIONS} -mf 
		{68KOBJECTS} 
 		"{Libraries}"MacRuntime.o 
 		"{Libraries}"Interface.o 
		-o "QDGX shell.mpwfat"
