/* ------------------------------------------------------------------------------

	FILENAME
		InitializeMessage.c

	DESCRIPTION
		This file contains the message procedure that will be invoked when the Printing Manager
		issues the Initialize message.

	COPYRIGHT
		Copyright Apple Computer, Inc. 1991 - 1996
		All rights reserved. 
	
	INTERFACE ROUTINES
		InitializeMessageProc

	MODIFICATION HISTORY
		12/03/91			Sam Weiss		Initial Implementation
		 6/14/96			cn					Updated to support Universal Interfaces 2.1.


------------------------------------------------------------------------------- */

#include <Types.h>
#include <Quickdraw.h>
#include <Memory.h>
#include <Resources.h>
#include <Dialogs.h>
#include <TextEdit.h>
#include <OSUtils.h>
#include <Packages.h>
#include <ToolUtils.h>
#include <Menus.h>
#include <String.h>
#include <Strings.h>
#include <Printing.h>
#include <FixMath.h>

#include <GXGraphics.h>

#include <Collections.h>
#include <GXMessages.h>

#include	<GXPrinting.h>

#include	"Additions.h"


extern long A5Size (void);
extern void A5Init (void *);


// Globals...


gxShape gSerialShape;


//------------------------------------------------------------------------------------

/*
	Name:					InitializeMessageProc
	
	Description:		Initialize the universal driver.

	Parameters:			long:				unused context
	
	Returns:				OSErr
	
	Preconditions:		none
								
	Postconditions:	none
	
*/

OSErr InitializeMessageProc (void) {

	OSErr anErr;
	
	anErr = NewMessageGlobals(A5Size(), A5Init);
	
	if (!anErr)
		gSerialShape = NULL;
	
	return anErr;
}
