#	File:		UserItems.make
#   Target:     UserItems
#   Sources:    UserItems.a UserItems.c UserItems.r
#   Created:    Sunday, Jun. 6, 1993 1:42:32 AM
#
#	Makefile for a printing extension that shows how
#	to handle hits and updates for userItems in panels.
#	
#	Dave Hersey
#	Apple Developer Technical Support
#	
#	06/06/93 - dmh - Created.
#	09/07/93 - dmh - Updated for b2.
#	12/18/93 - dmh - Updated for b3.
#    8/24/94 - dmh - Finalized.
#	 6/14/96 - cn  - Updated to support MPW Pro #19.
#

#	Alias to the path for the GX interface files.

INTPATH = "{CIncludes}"

#	Creator type we'll use:

kCreator = 'U$'


OBJECTS = UserItems.a.o UserItems.c.o
AsmOptions		= -sym off -i {INTPATH} -case obj
CompileOptions	= -opt full -d applec -b2 -r -i {INTPATH}

UserItems.a.o  UserItems.make UserItems.a
	 Asm {AsmOptions} UserItems.a
UserItems.c.o  UserItems.make UserItems.c
	SC {CompileOptions} UserItems.c

UserItems  UserItems.make UserItems.r {OBJECTS}
	Link	-ra =resSysHeap,resPurgeable	
			-t 'pext'						
			-c {kCreator}					
			-rt pext=0						
			-sg SEGS						
			-m EntryPoint					
			{OBJECTS}						
			"{Libraries}MacRuntime.o"			
			-o UserItems;
	SetFile UserItems -a iB;
	Rez -i {INTPATH} -rd -o UserItems UserItems.r -append 
